#!/usr/bin/python
# -*- encoding: utf-8 -*-

from sigpdv.tools.log import traced as Log
from sigpdv.models.db_utils import sess, exec_sql


class CadClientes(object):
    def __init__(self, parent=None):
        self.parent = parent

    @Log
    def atualiza_total_em_aberto(self, loja, query_cliente, total_em_aberto):
        self.parent.atualizando_total_em_aberto = True
        res = self.write(query_cliente, {'supcli_total_em_aberto': total_em_aberto})

        try:
            sql = """UPDATE supervisor_cad_clientes
                     SET    supcli_total_em_aberto = %s,
                            write_date = (NOW() at time zone 'UTC')
                     WHERE  supcli_cnpj_cpf = '%s'
                    """ % (str(total_em_aberto), query_cliente.supcli_cnpj_cpf)

            Log.info(str(sql))

            update_total_aberto = exec_sql(sql, 'S')

            if not update_total_aberto:
                return res

            sql_pdvs = """SELECT suppdv_caixa
                          FROM   supervisor_cad_pdvs
                          WHERE  suppdv_loja = %s """ % loja

            pdvs_ids = exec_sql(sql_pdvs, 'S', ret=True)

            for pdv in pdvs_ids:
                sql_select = """SELECT id
                                FROM   supervisor_mov_acao_pendente
                                WHERE  supeape_loja = %s
                                       AND supeape_pdv = %s
                                       AND supape_situacao = '%s'
                                       AND supape_tabela = '%s'
                """ % (loja, pdv['suppdv_caixa'], 'A', 'Clientes')

                acao_pendente = exec_sql(sql_select, 'S', ret=True)

                if not acao_pendente:
                    sql_insert = """INSERT INTO supervisor_mov_acao_pendente
                                                (supeape_loja,
                                                supeape_pdv,
                                                supape_situacao,
                                                supape_tabela)
                                    VALUES      (%s, %s, '%s', '%s')
                    """ % (loja, pdv['suppdv_caixa'], 'A', 'Clientes')

                    exec_sql(sql_insert, 'S')
        except Exception as e:
            Log.error(str(e))

        self.parent.atualizando_total_em_aberto = False
        return True

    @staticmethod
    def search(vals, order_by=None, limit=0):
        res = []
        try:
            filters = ''
            for key in vals:
                value = vals[key]
                if type(value) in [unicode, str]:
                    filters += ".filter(CaixaCadClientes.%s == '%s')" % (key, value)
                else:
                    filters += ".filter(CaixaCadClientes.%s == %s)" % (key, value)

            query = 'CaixaCadClientes.query%s' % filters

            if order_by:
                query += '.order_by(%s)' % order_by

            if limit:
                query += '.limit(%s)' % limit

            res_query = eval(query)
            if res_query.count():
                if res_query.count() == 1:
                    res = res_query.one()
                else:
                    res = res_query.all()
        except Exception as err:
            res = False
            Log.error(str(err))

        return res

    @Log
    def write(self, query_cliente, vals):
        res = False
        try:
            sess.begin()
            query_cliente.from_dict(vals)
            sess.commit()
            res = True
        except Exception as err:
            Log.error(str(err))

        return res
