#!/usr/bin/python
# -*- encoding: utf-8 -*-

from sigpdv.tools.log import traced as Log
from sigpdv.models.cad_promo2_data import CaixaCadPromo2 # deve ficar para executar 'eval()' no search
from sigpdv.models.db_utils import exec_sql
from decimal import Decimal
from datetime import datetime

TWOPLACES = Decimal(10) ** -2
TREPLACES = Decimal(10) ** -3


class CadPromo2(object):
    def __init__(self, parent):
        self.parent = parent

    @staticmethod
    def search(vals, order_by=None, limit=0):
        res = []
        try:
            filters = ''
            for key in vals:
                value = vals[key]
                if type(value) in [unicode, str]:
                    filters += ".filter(CaixaCadPromo2.%s == '%s')" % (key, value)
                else:
                    filters += ".filter(CaixaCadPromo2.%s == %s)" % (key, value)

            query = 'CaixaCadPromo2.query%s' % filters
            if order_by:
                query += '.order_by(%s)' % order_by

            if limit:
                query += '.limit(%s)' % limit

            res_query = eval(query)
            if res_query.count():
                if res_query.count() == 1:
                    res = res_query.one()
                else:
                    res = res_query.all()

        except Exception as err:
            res = False
            Log.error(str(err))

        return res

    @Log
    def calcula_promocao2(self):
        capa_id = self.parent.mov_capa.id
        indice = 0  # indice que vai varrer a lista de promocoes
        nItens = 0
        nItens1 = 0
        nDesconto = 0.0
        x = 0
        nqtde = 0
        nFez = 0
        ValDsc = 0.0
        DataPesq = ''
        sFilter = ''
        nSeq = 0
        PctsPai = 0
        Pacotes = 0
        varQtde = 0.0
        nCond = 0
        DescontoPack = 0.0
        lNaoPode = False
        MaxPcts = 0
        MaxPctOR = 0
        PctsOR = 0
        lTestar = False
        nElementos = 0
        QualItem = ''
        lItem = False
        QualSeq = ''
        nConta = 0
        MaxPromo = 0.0
        
        DataPesq = str(datetime.now())[:19]
        sql = ''' SELECT cpc.supproc_id_promo              AS id_promocao,
                         cpc.supproc_tipo_promo,
                         cpc.supproc_maximo                AS maximo,
                         cpc.supproc_scanntech             AS tipo_promo,
                         cpc.supproc_finalizadora_dinheiro AS somente_dineheiro,
                         cp2.suppro2_barras                AS barras,
                         cp2.suppro2_quantidade            AS quantidade,
                         cp2.suppro2_desconto              AS desconto,
                         cp2.suppro2_tipo_desconto,
                         cp2.suppro2_sequencial            AS sequencial
                 FROM caixa_cad_promo_capa   AS cpc
                 INNER JOIN caixa_cad_promo2 AS cp2 ON cp2.suppro2_capa_id = cpc.id
                 WHERE cpc.supproc_data_hora_inicio <= '{data}' at time zone 'UTC'
                   AND cpc.supproc_data_hora_fim >= '{data}' at time zone 'UTC'
                 ORDER BY cpc.supproc_id_promo, cp2.suppro2_sequencial
                 '''.format(data=DataPesq)
        RsPromo2P = exec_sql(sql, 'C')
        if RsPromo2P:
            while indice < len(RsPromo2P):
                nCond = 0
                QtdProd = []
                Filtros = []
                MaxPcts = 10000
                nID = RsPromo2P[indice].get('id_promocao')
                nSeq = RsPromo2P[indice].get('sequencial')
                DescontoPack = RsPromo2P[indice].get('desconto')
                MaxPromo = RsPromo2P[indice].get('maximo')
                lNaoPode = False
                sFilter = """supcor_capa_id = {capa_id}
                         AND supcor_venda_cancelamento='V' 
                         AND supcor_desconto_item < 0.01 
                         AND supcor_acrescimo_item < 0.01 
                         AND (supcor_item='""".format(capa_id=capa_id) + RsPromo2P[indice].get('barras') + "'"
                indice += 1
                while indice < len(RsPromo2P):
                    if RsPromo2P[indice].get('id_promocao') <> nID:
                        break
                    if RsPromo2P[indice].get('sequencial') == nSeq:
                        sFilter = sFilter + " OR supcor_item='" + RsPromo2P[indice].get('barras') + "'"
                    else:
                        nSeq = RsPromo2P[indice].get('sequencial')
                        indice -= 1
                        sFilter = sFilter + ")"
                        sql = "SELECT SUM(supcor_quantidade) AS nqtde FROM caixa_mov_corpos WHERE " + sFilter
                        TmpItens = exec_sql(sql, 'C')
                        if TmpItens:
                            nItens = TmpItens[0].get('nqtde') # Quantos itens encontrou do pai
                            if nItens >= RsPromo2P[indice].get('quantidade'):
                                QtdProd.append(RsPromo2P[indice].get('quantidade'))          # 'Quantos produtos dessa condicao sao usados no pack
                                Filtros.append(sFilter)                                      # 'Filtro dessa condicao
                                Pacotes = int(nItens / RsPromo2P[indice].get('quantidade'))  # 'Quantos pacotes consigo formas pra essa condicao
                                nCond = nCond + 1                                            # 'Soma numero de condicoes
                                if Pacotes < MaxPcts:
                                    MaxPcts = Pacotes    # 'Vamos guardar a menor qtd de packs dentre as condicoes
                            else:
                                lNaoPode = True
                                indice += 1
                                break

                        else:
                            lNaoPode = True
                            indice += 1
                            break

                        indice += 1

                        sFilter = """supcor_capa_id = {capa_id}
                                 AND supcor_venda_cancelamento='V'
                                 AND supcor_desconto_item < 0.01
                                 AND supcor_acrescimo_item < 0.01
                                 AND (supcor_item='""".format(capa_id=capa_id) + RsPromo2P[indice].get('barras') + "'"

                    indice += 1

                if lNaoPode == False: # Da pra fazer pack
                    indice -= 1
                    sFilter = sFilter + ")"
                    sql = "SELECT SUM(supcor_quantidade) as nqtde FROM caixa_mov_corpos WHERE " + sFilter
                    TmpItens = exec_sql(sql, 'C')
                    if TmpItens:
                        nItens = TmpItens[0].get('nqtde')  # 'Quantos itens encontrou do pai
                        if nItens >= RsPromo2P[indice].get('quantidade'):
                            QtdProd.append(RsPromo2P[indice].get('quantidade'))          # 'Quantos produtos dessa condicao s�o usados no pack
                            Filtros.append(sFilter)                                      # 'Filtro dessa condi��o
                            Pacotes = int(nItens / RsPromo2P[indice].get('quantidade'))  # 'Quantos pacotes consigo formas pra essa condi��o
                            nCond = nCond + 1                                            # 'Soma numero de condi��es
                            if Pacotes < MaxPcts:
                                MaxPcts = Pacotes                   # 'Vamos guardar a menor qtd de packs dentre as condi��es
                        else:
                            lNaoPode = True

                    else:
                        lNaoPode = True

                    if lNaoPode == False:
                        MaxPcts = MaxPromo if MaxPcts > MaxPromo else MaxPcts
                        for x in range(len(Filtros)):
                            sql = "SELECT * FROM caixa_mov_corpos WHERE " + Filtros[x] + " Order By supcor_sequencia"
                            TmpItens = exec_sql(sql, 'C')
                            indice_corpos = 0
                            nFez = 0
                            nqtde = (QtdProd[x] * MaxPcts)
                            while indice_corpos < len(TmpItens):
                                if TmpItens[indice_corpos].get('supcor_quantidade') >= (nqtde - nFez):
                                    nDesconto = Decimal((TmpItens[indice_corpos].get('supcor_preco_unitario') *
                                                         DescontoPack / 100) * (nqtde - nFez)).quantize(TWOPLACES)
                                    varQtde = (nqtde - nFez)
                                    nFez = nFez + (nqtde - nFez)
                                else:
                                    nDesconto = Decimal((TmpItens[indice_corpos].get('supcor_preco_unitario') * 
                                                         DescontoPack / 100) *
                                                         TmpItens[indice_corpos].get('supcor_quantidade')
                                                        ).quantize(TWOPLACES)
                                    varQtde = TmpItens[indice_corpos].get('supcor_quantidade')
                                    nFez = nFez + TmpItens[indice_corpos].get('supcor_quantidade')
                                    
                                self.parent.list_itens_desconto_promo.append(
                                    {'sequencia_item':TmpItens[indice_corpos].get('supcor_sequencia'),
                                     'desconto': nDesconto.quantize(TWOPLACES),
                                     'id_promo': str(nID).zfill(6),
                                     'quantidade': varQtde,
                                     'tipo_promo': '1' if RsPromo2P[indice].get('tipo_promo') else '2',
                                     'somente_dinheiro': RsPromo2P[indice].get('somente_dineheiro'),
                                    })
                                indice_corpos += 1
                                if str(nqtde).zfill(5) == str(nFez).zfill(5):
                                    break
                            
                    indice += 1
                    
                else:
                    while indice < len(RsPromo2P):
                        if RsPromo2P[indice].get('id_promocao') <> nID:
                            break
                        indice += 1

        return True
