#!/usr/bin/python
# -*- encoding: utf-8 -*-

from sigpdv.tools.log import traced as Log
from sigpdv.models.cad_promo3f_data import CaixaCadPromo3f # deve ficar para executar 'eval()' no search
from sigpdv.models.db_utils import exec_sql
from decimal import Decimal
from datetime import datetime

TWOPLACES = Decimal(10) ** -2
TREPLACES = Decimal(10) ** -3


class CadPromo3f(object):
    def __init__(self, parent):
        self.parent = parent

    @staticmethod
    def search(vals, order_by=None, limit=0):
        res = []
        try:
            filters = ''
            for key in vals:
                value = vals[key]
                if type(value) in [unicode, str]:
                    filters += ".filter(CaixaCadPromo3f.%s == '%s')" % (key, value)
                else:
                    filters += ".filter(CaixaCadPromo3f.%s == %s)" % (key, value)

            query = 'CaixaCadPromo3f.query%s' % filters
            if order_by:
                query += '.order_by(%s)' % order_by

            if limit:
                query += '.limit(%s)' % limit

            res_query = eval(query)
            if res_query.count():
                if res_query.count() == 1:
                    res = res_query.one()
                else:
                    res = res_query.all()

        except Exception as err:
            res = False
            Log.error(str(err))

        return res
