#!/usr/bin/python
# -*- encoding: utf-8 -*-

from sigpdv.tools.log import traced as Log
from sigpdv.models.cad_promo5p_data import CaixaCadPromo5p # deve ficar para executar 'eval()
from sigpdv.models.db_utils import exec_sql
from datetime import datetime
from decimal import Decimal


TWOPLACES = Decimal(10) ** -2


class CadPromo5p(object):
    def __init__(self, parent):
        self.parent = parent

    @staticmethod
    def search(vals, order_by=None, limit=0):
        res = []
        try:
            filters = ''
            for key in vals:
                value = vals[key]
                if type(value) in [unicode, str]:
                    filters += ".filter(CaixaCadPromo5p.%s == '%s')" % (key, value)
                else:
                    filters += ".filter(CaixaCadPromo5p.%s == %s)" % (key, value)

            query = 'CaixaCadPromo5p.query%s' % filters
            if order_by:
                query += '.order_by(%s)' % order_by

            if limit:
                query += '.limit(%s)' % limit

            res_query = eval(query)
            if res_query.count():
                if res_query.count() == 1:
                    res = res_query.one()
                else:
                    res = res_query.all()

        except Exception as err:
            res = False
            Log.error(str(err))

        return res

    @Log
    def calcula_promocao5(self):
        capa_id = self.parent.mov_capa.id
        indice = 0
        nItens = 0
        nItens1 = 0
        nDesconto = 0.0
        x = 0
        nQtde = 0
        nFez = 0
        ValDsc = 0.0
        DataPesq = ''
        sFilter = ''
        nSeq = 0
        PctsPai = 0
        QtdProd = []
        Filtros = []   
        Pacotes = 0
        PctsFilho = 0
        varQtde = 0.0
        nCond = 0
        DescontoPack = 0.0
        lNaoPode = False
        MaxPcts = 0
        lTestar = False
        PctsOR = 0
        MaxPctOR = 0
        QualSeq = ''
        nConta = 0
        QualItem = ''
        vPcts = 0
        nElementos = 0
        MaxPromo = 0.0
        
        
        DataPesq = str(datetime.now())[:19]
        sql = ''' SELECT cpc.id                            AS promo_capa_id,
                         cpc.supproc_id_promo              AS id_promocao,
                         cpc.supproc_tipo_promo,
                         cpc.supproc_maximo                AS maximo,
                         cpc.supproc_scanntech             AS tipo_promo,
                         cpc.supproc_finalizadora_dinheiro AS somente_dineheiro,
                         cp5.suppro5p_barras               AS barras,
                         cp5.suppro5p_quantidade           AS quantidade,
                         cp5.suppro5p_sequencial           AS sequencial
                 FROM caixa_cad_promo_capa   AS cpc
                 INNER JOIN caixa_cad_promo5p AS cp5 ON cp5.suppro5p_capa_id = cpc.id
                 WHERE cpc.supproc_data_hora_inicio <= '{data}' at time zone 'UTC'
                   AND cpc.supproc_data_hora_fim >= '{data}' at time zone 'UTC'
                 ORDER BY cpc.supproc_id_promo, cp5.suppro5p_sequencial
                 '''.format(data=DataPesq)
        RsPromo5P = exec_sql(sql, 'C')
        if RsPromo5P:
            while indice < len(RsPromo5P):
                nCond = 0
                MaxPcts = 10000
                nID = RsPromo5P[indice].get('id_promocao')
                promo_capa_id = RsPromo5P[indice].get('promo_capa_id')
                nSeq = RsPromo5P[indice].get('sequencial')
                MaxPromo = RsPromo5P[indice].get('maximo')
                DescontoPack = 0
                lNaoPode = False
                sFilter = """supcor_capa_id = {capa_id}
                         AND supcor_venda_cancelamento='V'  
                         AND supcor_desconto_item < 0.01 
                         AND supcor_acrescimo_item < 0.01 
                         AND (supcor_item='""".format(capa_id=capa_id) + RsPromo5P[indice].get('barras') + "'"
                indice += 1
                while indice < len(RsPromo5P):
                    if RsPromo5P[indice].get('id_promocao') <> nID: break
                    if RsPromo5P[indice].get('sequencial') == nSeq:
                        sFilter = sFilter + " OR supcor_item='" + RsPromo5P[indice].get('barras') + "'"
                    else:
                        nSeq = RsPromo5P[indice].get('sequencial')
                        indice -= 1
                        sFilter = sFilter + ")"
                        sql = "SELECT SUM(supcor_quantidade) AS nqtde FROM caixa_mov_corpos WHERE " + sFilter
                        TmpItens = exec_sql(sql, 'C')
                        if TmpItens:
                            nItens = TmpItens[0].get('nqtde') # Quantos itens encontrou do pai
                            if nItens >= RsPromo5P[indice].get('quantidade'):
                                QtdProd.append(RsPromo5P[indice].get('quantidade'))         # Quantos produtos dessa condicao sao usados no pack
                                Filtros.append(sFilter)                                     # Filtro dessa condicao
                                Pacotes = int(nItens / RsPromo5P[indice].get('quantidade')) # Quantos pacotes consigo formas pra essa condicao
                                nCond = nCond + 1                                           # Soma numero de condicoes
                                if Pacotes < MaxPcts:
                                    MaxPcts = Pacotes                     # Vamos guardar a menor qtd de packs dentre as condicoes
                            else:
                                lNaoPode = True
                                indice += 1
                                break
                            
                        else:
                            lNaoPode = True
                            indice += 1
                            break
                        
                        indice += 1
                        sFilter = """supcor_capa_id = {capa_id}
                                 AND supcor_venda_cancelamento='V'  
                                 AND supcor_desconto_item < 0.01 
                                 AND supcor_acrescimo_item < 0.01 
                                 AND (supcor_item='""".format(capa_id=capa_id) + RsPromo5P[indice].get('barras') + "'"
                    
                    indice += 1
                
                if lNaoPode == False: # Da pra fazer pack
                    indice -= 1
                    sFilter = sFilter + ")"
                    sql = "SELECT SUM(supcor_quantidade) AS nqtde FROM caixa_mov_corpos WHERE " + sFilter
                    TmpItens = exec_sql(sql, 'C')
                    if TmpItens:
                        nItens = TmpItens[0].get('nqtde') # Quantos itens encontrou do pai
                        if nItens >= RsPromo5P[indice].get('quantidade'):
                            QtdProd.append(RsPromo5P[indice].get('quantidade'))         # Quantos produtos dessa condicao s�o usados no pack
                            Filtros.append(sFilter)                                     # Filtro dessa condi��o
                            Pacotes = int(nItens / RsPromo5P[indice].get('quantidade')) # Quantos pacotes consigo formas pra essa condi��o
                            nCond = nCond + 1                                           # Soma numero de condi��es
                            if Pacotes < MaxPcts:
                                MaxPcts = Pacotes                     # Vamos guardar a menor qtd de packs dentre as condi��es
                        else:
                            lNaoPode = True
                        
                    else:
                        lNaoPode = True
                    
                    if lNaoPode == False:
                        MaxPcts = MaxPromo if MaxPcts > MaxPromo else MaxPcts
                        sql = '''SELECT cpc.supproc_id_promo              AS id_promocao,
                                        cpc.supproc_tipo_promo,
                                        cpc.supproc_maximo                AS maximo,
                                        cpc.supproc_scanntech             AS tipo_promo,
                                        cpc.supproc_finalizadora_dinheiro AS somente_dineheiro,
                                        cp5.suppro5f_barras               AS barras,
                                        cp5.suppro5f_quantidade           AS quantidade
                                 FROM caixa_cad_promo_capa    AS cpc
                                 INNER JOIN caixa_cad_promo5f AS cp5 ON cp5.suppro5f_capa_id = cpc.id
                                 WHERE cpc.id = {capa_id}
                                 ORDER BY cpc.supproc_id_promo
                                 '''.format(capa_id=promo_capa_id)
                        RsPromo5F = exec_sql(sql, 'C')
                        indice_5f = 0
                        if RsPromo5F:
                            sFilter = """supcor_capa_id = {capa_id}
                                 AND supcor_venda_cancelamento='V'  
                                 AND supcor_desconto_item < 0.01 
                                 AND supcor_acrescimo_item < 0.01 
                                 AND (supcor_item='""".format(capa_id=capa_id) + RsPromo5F[indice_5f].get('barras') + "'"
                            indice_5f += 1
                            while indice_5f < len(RsPromo5F):
                                sFilter = sFilter + " OR supcor_item='" + RsPromo5F[indice_5f].get('barras') + "'"
                                indice_5f += 1
                            
                            indice_5f -= 1
                            sFilter = sFilter + ")"
                            sql = "SELECT SUM(supcor_quantidade) AS nqtde FROM caixa_mov_corpos WHERE " + sFilter
                            ItensTmp = exec_sql(sql, 'C')
                            if ItensTmp:
                                nItens1 = ItensTmp[0].get('nqtde')
                                if nItens1 >= RsPromo5F[indice_5f].get('quantidade'):
                                    PctsFilho = int(nItens1 / RsPromo5F[indice_5f].get('quantidade'))
                                    Pacotes = PctsFilho if MaxPcts >= PctsFilho else MaxPcts
                                    
                                    sql = "SELECT * FROM caixa_mov_corpos WHERE " + sFilter + " Order By supcor_sequencia"
                                    ItensTmp = exec_sql(sql, 'C')
                                    indice_corpos_f = 0
                                    nFez = 0
                                    nQtde = (RsPromo5F[indice_5f].get('quantidade') * Pacotes)
                                    print 'Primeiro o filho...'
                                    while indice_corpos_f < len(ItensTmp):
                                        if ItensTmp[indice_corpos_f].get('supcor_quantidade') > (nQtde - nFez):
                                            nDesconto = ItensTmp[indice_corpos_f].get('supcor_preco_unitario') * \
                                                        (nQtde - nFez)
                                            varQtde = (nQtde - nFez)
                                            nFez = nFez + (nQtde - nFez)
                                        else:
                                            nDesconto = (ItensTmp[indice_corpos_f].get('supcor_preco_unitario') * 
                                                         ItensTmp[indice_corpos_f].get('supcor_quantidade')) - Decimal(0.01)
                                            varQtde = ItensTmp[indice_corpos_f].get('supcor_quantidade')
                                            nFez = nFez + ItensTmp[indice_corpos_f].get('supcor_quantidade')
                                        
                                        self.parent.list_itens_desconto_promo.append(
                                            {'sequencia_item':ItensTmp[indice_corpos_f].get('supcor_sequencia'),
                                             'desconto': nDesconto.quantize(TWOPLACES),
                                             'id_promo': str(nID).zfill(6),
                                             'quantidade': varQtde,
                                             'tipo_promo': '1' if RsPromo5F[indice_5f].get('tipo_promo') else '2',
                                             'somente_dinheiro': RsPromo5F[indice_5f].get('somente_dineheiro'),
                                            })
                                        indice_corpos_f += 1
                                        if str(nQtde).zfill(5) == str(nFez).zfill(5):
                                            break
                                    
                                    print 'Agora o pai...'
                                    for x in range(len(Filtros)):
                                        sql = "SELECT * FROM caixa_mov_corpos WHERE " + Filtros[x] + " Order By supcor_sequencia"
                                        TmpItens = exec_sql(sql, 'C')
                                        indice_corpos_p = 0
                                        nFez = 0
                                        nQtde = (QtdProd[x] * Pacotes)
                                        while indice_corpos_p < len(TmpItens):
                                            if TmpItens[indice_corpos_p].get('supcor_quantidade') >= (nQtde - nFez):
                                                nDesconto = Decimal(0)
                                                varQtde = (nQtde - nFez)
                                                nFez = nFez + (nQtde - nFez)
                                            else:
                                                nDesconto = Decimal(0)
                                                varQtde = TmpItens[indice_corpos_p].get('supcor_quantidade')
                                                nFez = nFez + TmpItens[indice_corpos_p].get('supcor_quantidade')

                                            self.parent.list_itens_desconto_promo.append(
                                                {'sequencia_item':TmpItens[indice_corpos_p].get('supcor_sequencia'),
                                                 'desconto': nDesconto.quantize(TWOPLACES),
                                                 'id_promo': str(nID).zfill(6),
                                                 'quantidade': varQtde,
                                                 'tipo_promo': '1' if RsPromo5P[indice].get('tipo_promo') else '2',
                                                 'somente_dinheiro': RsPromo5P[indice].get('somente_dineheiro'),
                                            })
                                            indice_corpos_p += 1
                                            if str(nQtde).zfill(5) == str(nFez).zfill(5):
                                                break
                    indice += 1
                else:
                    while indice < len(RsPromo5P):
                        if RsPromo5P[indice].get('id_promocao') <> nID:
                            break
                        indice += 1

        return True
