#!/usr/bin/python
# -*- encoding: utf-8 -*-

from sigpdv.tools.log import traced as Log
from sigpdv.models.cad_promo7_data import CaixaCadPromo7 # deve ficar para executar 'eval()
from sigpdv.models.db_utils import exec_sql
from datetime import datetime
from decimal import Decimal

TWOPLACES = Decimal(10) ** -2


class CadPromo7(object):
    def __init__(self, parent):
        self.parent = parent

    @staticmethod
    def search(vals, order_by=None, limit=0):
        res = []
        try:
            filters = ''
            for key in vals:
                value = vals[key]
                if type(value) in [unicode, str]:
                    filters += ".filter(CaixaCadPromo7.%s == '%s')" % (key, value)
                else:
                    filters += ".filter(CaixaCadPromo7.%s == %s)" % (key, value)

            query = 'CaixaCadPromo7.query%s' % filters
            if order_by:
                query += '.order_by(%s)' % order_by

            if limit:
                query += '.limit(%s)' % limit

            res_query = eval(query)
            if res_query.count():
                if res_query.count() == 1:
                    res = res_query.one()
                else:
                    res = res_query.all()

        except Exception as err:
            res = False
            Log.error(str(err))

        return res

    @Log
    def calcula_promocao7(self):
        capa_id = self.parent.mov_capa.id
        indice = 0
        nItens = 0
        nDesconto = 0.0
        x = 0
        nQtde = 0
        nFez = 0
        ValDsc = 0.0
        Agora = ''
        DataPesq = ''
        sFilter = ''
        varQtde = 0.0
        nSeq = 0
        PctsPai = 0
        Pacotes = 0
        nCond = 0
        DescontoPack = 0.0
        lNaoPode = False
        MaxPcts = 0
        lTestar = False
        ItensPct = 0.0
        errPromo = False
        MaxPromo = 0.0
        
        DataPesq = str(datetime.now())[:19]
        sql = ''' SELECT cpc.supproc_id_promo              AS id_promocao,
                         cpc.supproc_tipo_promo,
                         cpc.supproc_maximo                AS maximo,
                         cpc.supproc_scanntech             AS tipo_promo,
                         cpc.supproc_finalizadora_dinheiro AS somente_dineheiro,
                         cp7.suppro7_barras                AS barras,
                         cp7.suppro7_quantidade            AS quantidade,
                         cp7.suppro7_desconto              AS desconto,
                         cp7.suppro7_tipo_desconto,
                         cp7.suppro7_sequencial    AS sequencial
                 FROM caixa_cad_promo_capa   AS cpc
                 INNER JOIN caixa_cad_promo7 AS cp7 ON cp7.suppro7_capa_id = cpc.id
                 WHERE cpc.supproc_data_hora_inicio <= '{data}' at time zone 'UTC'
                   AND cpc.supproc_data_hora_fim >= '{data}' at time zone 'UTC'
                 ORDER BY cpc.supproc_id_promo, cp7.suppro7_sequencial
                 '''.format(data=DataPesq)
        RsPromo7 = exec_sql(sql, 'C')
        if RsPromo7:
            while indice < len(RsPromo7):
                nCond = 0
                MaxPcts = 10000
                nID = RsPromo7[indice].get('id_promocao')
                nSeq = RsPromo7[indice].get('sequencial')
                DescontoPack = RsPromo7[indice].get('desconto')
                MaxPromo = RsPromo7[indice].get('maximo')
                lNaoPode = False
                QtdProd = []
                Vr_itens_pack = Decimal(0) # valor total do pack
                Filtros = []
                sFilter = """supcor_capa_id = {capa_id}
                         AND supcor_venda_cancelamento='V'  
                         AND supcor_desconto_item < 0.01 
                         AND supcor_acrescimo_item < 0.01 
                         AND (supcor_item='""".format(capa_id=capa_id) + RsPromo7[indice].get('barras') + "'"
                indice += 1
                while indice < len(RsPromo7):
                    if RsPromo7[indice].get('id_promocao') <> nID:
                        break
                    if RsPromo7[indice].get('sequencial') == nSeq:
                        sFilter = sFilter + " OR supcor_item='" + RsPromo7[indice].get('barras') + "'"
                    else:
                        nSeq = RsPromo7[indice].get('sequencial')
                        indice -= 1
                        sFilter = sFilter + ")"
                        sql = """SELECT SUM(supcor_quantidade) AS nqtde,
                                        supcor_preco_unitario  AS preco_unitatio
                                 FROM caixa_mov_corpos WHERE """ + sFilter + """GROUP BY  supcor_preco_unitario"""
                        TmpItens = exec_sql(sql, 'C')
                        if TmpItens:
                            nItens = sum(map(lambda x: x.get('nqtde'), TmpItens)) # Quantos itens encontrou do pai
                            if nItens >= RsPromo7[indice].get('quantidade'):
                                QtdProd.append(RsPromo7[indice].get('quantidade'))         # 'Quantos produtos dessa condicao s�o usados no pack
                                Vr_itens_pack += sum(map(lambda x: RsPromo7[indice].get('quantidade')
                                                               * x.get('preco_unitatio'), TmpItens))
                                Filtros.append(sFilter)                                    # 'Filtro dessa condi��o
                                Pacotes = nItens >= RsPromo7[indice].get('quantidade') and 1 or 0 # 1 ou 0 para esta promocao
                                nCond = nCond + 1                                          # 'Soma numero de condi��es
                                if Pacotes < MaxPcts:
                                    MaxPcts = Pacotes                # 'Vamos guardar a menor qtd de packs dentre as condi��es
                            else:
                                lNaoPode = True
                                indice += 1
                                break
                                
                        else:
                            lNaoPode = True
                            indice += 1
                            break
                            
                        indice += 1
                        sFilter = """supcor_capa_id = {capa_id}
                                 AND supcor_venda_cancelamento='V'  
                                 AND supcor_desconto_item < 0.01 
                                 AND supcor_acrescimo_item < 0.01 
                                 AND (supcor_item='""".format(capa_id=capa_id) + RsPromo7[indice].get('barras') + "'"

                    indice += 1
                
                if lNaoPode == False: # Da pra fazer pack
                    indice -= 1
                    sFilter = sFilter + ")"
                    sql = """SELECT SUM(supcor_quantidade) AS nqtde,
                                    supcor_preco_unitario  AS preco_unitatio
                            FROM caixa_mov_corpos WHERE """ + sFilter + """GROUP BY  supcor_preco_unitario"""
                    TmpItens = exec_sql(sql, 'C')
                    if TmpItens:
                        nItens = sum(map(lambda x: x.get('nqtde'), TmpItens)) # 'Quantos itens encontrou do pai
                        if nItens >= RsPromo7[indice].get('quantidade'):
                            QtdProd.append(RsPromo7[indice].get('quantidade'))           # 'Quantos produtos dessa condicao s�o usados no pack
                            Vr_itens_pack += sum(map(lambda x: RsPromo7[indice].get('quantidade')
                                                           * x.get('preco_unitatio'), TmpItens))
                            Filtros.append(sFilter)                                      # 'Filtro dessa condi��o
                            Pacotes = nItens >= RsPromo7[indice].get('quantidade') and 1 or 0 # 1 ou 0 para esta promocao
                            nCond = nCond + 1                                            #  'Soma numero de condi��es
                            if Pacotes < MaxPcts:
                                MaxPcts = Pacotes                  #  'Vamos guardar a menor qtd de packs dentre as condi��es
                        else:
                            lNaoPode = True
                        
                    else:
                        lNaoPode = True
                    
                    if lNaoPode == False:
                        MaxPcts = MaxPromo if MaxPcts > MaxPromo else MaxPcts
                        for x in range(len(Filtros)):
                            sql = "SELECT * FROM caixa_mov_corpos WHERE " + Filtros[x] + " Order By supcor_sequencia"
                            TmpItens = exec_sql(sql, 'C')
                            indice_corpos = 0
                            nQtde = (QtdProd[x] * MaxPcts)
                            qtd_itens_vendidos = sum(map(lambda x: x.get('supcor_quantidade'), TmpItens))
                            if qtd_itens_vendidos < nQtde:
                                continue

                            while indice_corpos < len(TmpItens):
                                if RsPromo7[indice].get('suppro7_tipo_desconto') == '$':
                                    nDesconto = DescontoPack * TmpItens[indice_corpos].get('supcor_quantidade')
                                else: # desconto percentual
                                    nDesconto = TmpItens[indice_corpos].get('supcor_preco_total') * DescontoPack / 100
                                    
                                nDesconto = Decimal(nDesconto).quantize(TWOPLACES)
                                if nDesconto > 0:
                                    self.parent.list_itens_desconto_promo.append(
                                    {'sequencia_item':TmpItens[indice_corpos].get('supcor_sequencia'),
                                     'desconto': nDesconto,
                                     'id_promo': str(nID).zfill(6),
                                     'quantidade': varQtde,
                                     'tipo_promo': '1' if RsPromo7[indice].get('tipo_promo') else '2',
                                     'somente_dinheiro': RsPromo7[indice].get('somente_dineheiro'),
                                    })
                                    indice_corpos += 1
                                else:
                                    Log.info("Desconto Inválido. Promoção-7: " + str(nID).zfill(6))
                                    promo_delete = filter(lambda y: y.get('id_promo') == str(nID).zfill(6)
                                                              and y.get('id_promo') == '7', self.parent.list_itens_desconto_promo)
                                    map(lambda x: self.parent.list_itens_desconto_promo.remove(x), promo_delete)
                                    errPromo = True
                                    break

                            if errPromo:
                                break

                    indice += 1
                else:
                    while indice < len(RsPromo7):
                        if RsPromo7[indice].get('id_promocao') <> nID:
                            break

                        indice += 1

        return True
