#!/usr/bin/python
# -*- encoding: utf-8 -*-

from sigpdv.tools.log import traced as Log
from decimal import Decimal
from sigpdv.control.utils import exec_sql


class CadPromoCapa(object):
    def __init__(self, parent):
        self.parent = parent

    @Log
    def calcula_descontos_promo(self, dinheiro=False):
        if self.parent._coupon_totalize: # cupom ja totalizado, nao precisa calcular o desconto
            return 'Cupom totalizado'

        # caso tenha calculado alguma promocao de dinheiro que possa ter bloqueado a pesquisa de
        # socio tocedor, ao trocar de tela de pagamento indica que o socio nao foi calculado
        if not dinheiro:
            for i in self.parent.list_itens_desconto_promo:
                if i.get('somente_dinheiro'):
                    self.parent.desconto_socio_calculado = False
                    break

        self.parent.desconto_promo = Decimal(0)
        self.parent.list_itens_desconto_promo = []
        self.parent.obj_cad_promo1.calcula_promocao1()
        self.parent.obj_cad_promo2.calcula_promocao2()
        self.parent.obj_cad_promo3p.calcula_promocao3()
        self.parent.obj_cad_promo4.calcula_promocao4()
        self.parent.obj_cad_promo5p.calcula_promocao5()
        self.parent.obj_cad_promo6.calcula_promocao6()
        self.parent.obj_cad_promo7.calcula_promocao7()

        total_desconto = 0
        aux = []
        dict_lista = {}
        promo_ids = map(lambda x: str(int(x.get('id_promo'))), self.parent.list_itens_desconto_promo)
        if promo_ids:
            for i in exec_sql("""SELECT * 
                                 FROM caixa_cad_lista_clientes 
                                 WHERE supclc_id_promo in (%s)""" % ','.join(promo_ids)):
                promo_id = ('%s' % i.get('supclc_id_promo')).zfill(6)
                cliente = (i.get('supclc_cnpj_cpf')).zfill(15)
                if promo_id not in dict_lista:
                    dict_lista[promo_id] = [cliente]
                else:
                    dict_lista[promo_id].append(cliente)

        for i in self.parent.list_itens_desconto_promo:
            # retira as promocoes que sao em dinheiro mas o pagamento nao foi feito com o mesmo
            if i.get('somente_dinheiro') and not dinheiro:
                continue

            lista_clientes = dict_lista.get(i.get('id_promo')) or []
            # as promocoes que sao especificas de clientes na lista mas o cliente do cupom nao
            # esta na lista, Obs tipo_promo = 2 sig, ignora as Scanntech
            if i.get('tipo_promo') == '2' and lista_clientes and \
                    self.parent.cliente.supcli_cnpj_cpf not in lista_clientes:
                continue

            #Todo: ao trocar a ordem das promocoes verificar como proceder nesta parte
            if self.parent.dict_mov_corpos_socio and \
                              self.parent.dict_mov_corpos_socio.get('%s' % i.get('sequencia_item')):
                self.parent.desconto_socio_torcedor -= self.parent.dict_mov_corpos_socio.get(
                                                    '%s' % i.get('sequencia_item')).get('desconto')
                del self.parent.dict_mov_corpos_socio['%s' % i.get('sequencia_item')]

            total_desconto += i.get('desconto')
            aux.append(i)

        self.parent.list_itens_desconto_promo = aux
        if total_desconto > 0:
            self.parent.desconto_promo = total_desconto

        self.parent.atualiza_valor_a_pagar()
        Ecfk_ScnPlusOk = True

        return self.parent.list_itens_desconto_promo or 'Sem promocao'