#!/usr/bin/python
# -*- coding: utf-8 -*-

from sigpdv.tools.config import config
from sigpdv.tools.log import traced as Log
from sigpdv.control.mov_cupom_servidor import MovCupomServidor
from sigpdv.control.relatorio_gerencial import GerencialReport
from sigpdv.ui.messagebox import MSG_ERROR, MSG_INFO, MSG_NONE, message_dlg
from SigUtils.numero import getNumeroEditado
from datetime import datetime
in_coupon = 3
in_end_sale = 13


class Doacao():

    def __init__(self, parent):
        self.parent = parent

    @Log
    def efetua_doacao(self, cod_totalizador, name_finalizadora, valor):
        self.parent.bloqueia_botoes()
        self.parent._set_screen_state(in_end_sale)
        self.parent.show_info_proccess(True, 'Efetuando Doação. Aguarde...')
        try:
            corpo = 'Item                                   Valor: \n' \
                    '{:<20}                  R$ {:<7}'.format(name_finalizadora, valor)
            texto = self.parent.obj_cupom_fiscal.get_texto_cupom(corpo)
            print '\n\n', texto
            self.parent.obj_impressoras.supcci_imprimir(texto)

        except Exception as e:
            self.parent.show_info_proccess(False)
            return False

        self.parent.obj_cupom_fiscal.cria_capa_cupom_gerencial(cod_totalizador, valor)
        self.cria_cupom_vinculado(valor)
        return True

    @Log
    def cria_cupom_vinculado(self, valor):
        if not config['imprimir_2via_doacao']:
            return "Doacao sem a via do cliente!"

        parametro = self.parent.obj_parametros.get_by()
        msg = '%s' % self.parent.remove_accents(parametro.supcfp_mensagem_doacao or '')
        text = '%s%s' %('Valor da doacao: R$%s\n\n' % (getNumeroEditado(valor)), msg)
        texto = self.parent.obj_cupom_fiscal.get_texto_cupom(text)
        print '\n\nVia Cliente:\n\n', texto
        self.parent.obj_impressoras.supcci_imprimir(texto)