#!/usr/bin/python
# -*- encoding: utf-8 -*-

from datetime import date, datetime
from sigpdv.tools.log import traced as Log
from sigpdv.models.mov_autorizacoes_data import CaixaMovAutorizacoes
from sigpdv.models.db_utils import sess


class MovAutorizacoes():
    def __init__(self):
        pass

    @Log
    def search(self, vals, order_by=None, limit=0):
        res = []
        try:
            filters = ''
            for key in vals:
                value = vals[key]
                filters += '.filter(CaixaMovAutorizacoes.%s == %s)' % (key, value)

            query = 'CaixaMovAutorizacoes.query%s' % filters

            if order_by:
                query += '.order_by(%s)' % order_by

            if limit:
                query += '.limit(%s)' % limit

            res_query = eval(query)
            if res_query.count():
                if res_query.count() == 1:
                    res = res_query.one()
                else:
                    res = res_query.all()
        except Exception as err:
            res = False
            Log.error(str(err))

        return res

    @Log
    def create(self, vals):
        try:
            values = ''
            for key in vals:
                value = vals[key]
                if type(value) in [unicode, str, date, datetime]:
                    values += "%s='%s', " % (key, value)
                else:
                    values += "%s=%s, " % (key, value)
            sess.begin()
            res = eval("CaixaMovAutorizacoes(%s)" % values)
            sess.commit()
        except Exception as err:
            sess.rollback()
            res = False
            Log.error(str(err))
        return res

    @Log
    def write(self, query_autorizacoes, vals):
        res = False
        try:
            sess.begin()
            query_autorizacoes.from_dict(vals)
            sess.commit()
            res = True
        except Exception as err:
            sess.rollback()
            Log.error(str(err))
        return res
