#!/usr/bin/python
# -*- encoding: utf-8 -*-

from sigpdv.tools.log import traced as Log
from sigpdv.models.mov_capa_data import CaixaMovCapa
from sigpdv.models.db_utils import sess, exec_sql
from datetime import datetime, date


class MovCapa():
    def __init__(self, parent=None):
        self.parent = parent

    @Log
    def search(self, vals, order_by=None, limit=0):
        res = False
        try:
            filters = ''
            for key in vals:
                value = vals[key]
                if type(value) in [unicode, str, date, datetime]:
                    filters += ".filter(CaixaMovCapa.%s == '%s')" % (key, value)
                elif type(value) == list:
                    filters += ".filter(CaixaMovCapa.%s.in_(%s))" % (key, value)

                else:
                    filters += ".filter(CaixaMovCapa.%s == %s)" % (key, value)

            query = 'CaixaMovCapa.query%s' % filters

            if order_by:
                query += '.order_by(%s)' % order_by

            if limit:
                query += '.limit(%s)' % limit

            res_query = eval(query)
            if res_query.count():
                if res_query.count() == 1:
                    res = res_query.one()
                else:
                    res = res_query.all()
        except Exception as err:
            res = False
            Log.error(str(err))

        return res

    @Log
    def create(self, vals):
        try:
            if not vals.get('supcap_operador_id') and vals.get('supcap_tipo') not in ['V', 'C']:
                op_id  = exec_sql("""SELECT id
                                     FROM caixa_cad_operadores
                                     ORDER BY id
                                     LIMIT 1""", 'C', ret=True)
                if not op_id:
                    raise Exception('Nenhum registro encontrado na tabela de operadores!')

                vals['supcap_operador_id'] = op_id[0].get('id')

            values = ''
            for key in vals:
                value = vals[key]
                if type(value) in [unicode, str, date, datetime]:
                    values += "%s='%s', " % (key, value)
                else:
                    values += "%s=%s, " % (key, value)

            sess.begin()
            res = eval("CaixaMovCapa(%s)" % values)
            sess.commit()
            return res
        except Exception as err:
            sess.rollback()
            Log.error('Erro ao gravar Capa do Cupom! \n%s' % str(err))
            return False


    @Log
    def write(self, query_capa, vals):
        res = False
        try:
            sess.begin()
            query_capa.from_dict(vals)
            sess.commit()
            res = True
        except Exception as err:
            sess.rollback()
            Log.error(str(err))

        return res

    @Log
    def delete(self, query_capa):
        res = False
        try:
            sess.begin()
            query_capa.delete()
            sess.commit()
            res = True
        except Exception as err:
            sess.rollback()
            Log.error(str(err))

        return res