#!/usr/bin/python
# -*- encoding: utf-8 -*-

from sigpdv.tools.log import traced as Log
from sigpdv.models.mov_cupom_servidor_data import CaixaMovCupomServidor
from sigpdv.models.db_utils import sess


class MovCupomServidor():
    def __init__(self):
        pass

    @staticmethod
    def search(vals, order_by=None, limit=0):
        res = []
        try:
            filters = ''
            for key in vals:
                value = vals[key]
                filters += '.filter(CaixaMovCupomServidor.%s == %s)' % (key, value)

            query = 'CaixaMovCupomServidor.query%s' % filters

            if order_by:
                query += '.order_by(%s)' % order_by

            if limit:
                query += '.limit(%s)' % limit

            res_query = eval(query)
            if res_query.count():
                if res_query.count() == 1:
                    res = res_query.one()
                else:
                    res = res_query.all()
        except Exception as err:
            res = False
            Log.error(str(err))

        return res

    @Log
    def create(self, vals):
        try:
            res = self.search({'supcse_capa_id': vals.get('supcse_capa_id')})
            if res:
                return res

            vals['supcse_enviado'] = False
            values = ''
            for key in vals:
                value = vals[key]
                if type(value) in [unicode, str]:
                    values += "%s='%s', " % (key, value)
                else:
                    values += "%s=%s, " % (key, value)
            sess.begin()
            res = eval("CaixaMovCupomServidor(%s)" % values)
            sess.commit()
        except Exception as err:
            sess.rollback()
            res = False
            Log.error(str(err))
        return res

    @Log
    def write(self, query_cupom_servidor, vals):
        res = False
        try:
            sess.begin()
            query_cupom_servidor.from_dict(vals)
            sess.commit()
            res = True
        except Exception as err:
            sess.rollback()
            Log.error(str(err))
        return res
