#!/usr/bin/python
# -*- encoding: utf-8 -*-

from sigpdv.models.mov_meios_pagamentos_data import CaixaMovMeiosPagamentos
from sigpdv.tools.log import traced as Log
from sigpdv.models.db_utils import sess


class MovMeiosPagamentos():
    def __init__(self):
        pass

    @staticmethod
    def gravar_meios_pagamento(loja_id, caixa_id, data_cupom, tipo_cupom,
                               tipo_comprovante, valor, finalizadora=0, nome_finalizadora=''):
        res = False
        if str(tipo_cupom).lower() in ['b', 'n', 'v', 'w', 'u']:
            try:
                meios_pgto = CaixaMovMeiosPagamentos.get_by(
                    supmpa_data_movimento=data_cupom, supmpa_loja=loja_id,
                    supmpa_caixa=caixa_id, supmpa_finalizadora=finalizadora,
                    supmpa_descricao_finalizadora=nome_finalizadora,
                    supmpa_tipo_documento=tipo_comprovante)

                if meios_pgto:
                    sess.begin()
                    meios_pgto.supmpa_valor = (meios_pgto.supmpa_valor + valor)
                    sess.commit()
                else:
                    sess.begin()
                    meios_pgto = CaixaMovMeiosPagamentos(
                        supmpa_data_movimento=data_cupom,
                        supmpa_loja=loja_id,
                        supmpa_caixa=caixa_id,
                        supmpa_finalizadora=finalizadora,
                        supmpa_descricao_finalizadora=nome_finalizadora,
                        supmpa_tipo_documento=tipo_comprovante,
                        supmpa_valor=valor)
                    sess.commit()

                res = meios_pgto

            except Exception as err:
                sess.rollback()
                Log.error('Erro ao gravar meios de pagamentos! %s ' % str(err))
                return False

        return res