# -*- Mode: Python; coding: utf-8 -*-
from reportlab.lib.units import cm, mm
from reportlab.pdfgen import canvas
from reportlab.lib.pagesizes import A4
from os import system
from sigpdv.models.tbl_pve_dav import dav_capa, dav_corpo, configuracao, itens
from decimal import Decimal

PW = A4[0]
PR = A4[1]
PB = (1 * cm, 1 * cm, A4[0] - 2 * cm, A4[1] - 2 * cm)
IT = PB[3] + .5 * cm
IL = PB[0] + 5
SP = 4.5 * mm

def gerar_rel_dav(id_dav, loja):
    capa = dav_capa.get_by(IdDav=id_dav)
    corpo = dav_corpo.query.filter(dav_corpo.IdDav == id_dav)
    loja = configuracao.get_by(Loja=loja)

    emi_nome = loja.Cliente
    emi_cnpj = loja.CNPJ
    dest_nome = capa.NomeCliente
    dest_doc = capa.Cliente
    filename = "dav_pve/relatorios/dav%010d.pdf" % id_dav
    c = canvas.Canvas(filename, pagesize=A4)
    c.setLineWidth(.3)
    c.setFont('Courier', 10)
    c.setTitle('DAV: %010d' % id_dav)
    c.setAuthor('Sig Soluções')

    c.rect(PB[0], PB[1], PB[2], PB[3])

    c.drawCentredString(A4[0] / 2, IT, 'DOCUMENTO AUXILIAR DE VENDA - PEDIDO')
    c.line(PB[0], IT - SP / 1.5, PB[2] + 1 * cm, IT - SP / 1.5)
    c.drawCentredString(A4[0] / 2, IT - 2 * SP,
                        u'NÃO É DOCUMENTO FISCAL - NÃO É VÁLIDO COMO RECIBO E COMO GARANTIA DE MERCADORIA -')
    c.drawCentredString(A4[0] / 2, IT - 3 * SP, u'NÃO COMPROVA PAGAMENTO')
    c.line(PB[0], IT - 5.5 * SP / 1.5, PB[2] + 1 * cm, IT - 5.5 * SP / 1.5)
    c.drawCentredString(A4[0] / 2, IT - 5 * SP, u'Identificação do Estabelecimento')
    c.drawString(IL, IT - 6 * SP, 'Denominação: %s' % emi_nome)
    c.drawString(IL * 12, IT - 6 * SP, u'CNPJ: %s' % emi_cnpj)
    c.drawString(IL, IT - 8 * SP, 'Identificação do Destinatário')
    c.drawString(IL, IT - 9 * SP, 'Nome: %s' % dest_nome)
    c.drawString(IL * 12, IT - 9 * SP, u'CNPJ: %s' % dest_doc)
    c.drawString(IL, IT - 10 * SP, 'Nº do documento: %010d' % id_dav)
    c.drawString(IL * 9, IT - 10 * SP, 'Nº do documento Fiscal:')
    c.line(PB[0] * 15.5, IT - 15.3 * SP / 1.5, PB[2] + .8 * cm, IT - 15.3 * SP / 1.5)
    c.line(PB[0], IT - 16 * SP / 1.5, PB[2] + 1 * cm, IT - 16 * SP / 1.5)

    c.setFont('Courier', 8)
    c.drawString(IL, IT - 12 * SP, 'PRODUTO')
    c.drawString(IL * 4, IT - 12 * SP, 'QUANTIDADE')
    c.drawString(IL * 8, IT - 12 * SP, 'VR UNITARIO')
    inc = 13
    d = Decimal(0)
    t_acr, t_desc, total = d, d, d
    for i in corpo:
        i_rel = itens.get_by(CodigoItem=i.Item)
        cod = i_rel.CodigoItem
        nome = i_rel.Descricao
        qtd = '%.3f' % i.Quantidade
        acr = '%.2f' % i.AcrescimoItem
        desc = '%.2f' % i.DescontoItem
        vr_u = '%.2f' % i_rel.Preco
        vr_t = '%.2f' % i.PrecoTotal
        t_acr += i.DescontoItem
        t_desc += i.AcrescimoItem
        if i.VendaCancelamento == 'V':
            vc = ''
            total += i.PrecoTotal
        else:
            vc = 'Cancelado'
            vr_t = '-%.2f' % i.PrecoTotal
        s = '%s %s %s %s %s %s %s %s' % (cod, nome.ljust(30, ' '), qtd.rjust(5, ' '), acr.rjust(9, ' '), desc.rjust(9, ' '),
                                      vr_u.rjust(12, ' '), vr_t.rjust(12, ' '), vc)
        c.drawString(IL, IT - inc * SP, s)
        inc += 1
    inc += 1
    t_acr, t_desc, total = '%.2f' % t_acr, '%.2f' % t_desc, '%.2f' % total
    s = '%s %s %s %s %s' % (' ' * 51, t_acr.rjust(9, ' '), t_desc.rjust(9, ' '), ' ' * 12, total.rjust(12, ' '))
    c.drawString(IL, IT - inc * SP, s)
    inc += 1
    s = 'Total:'

    c.save()

    system('gnome-open %s' % filename)


