from PySide import QtGui, QtCore
import sys
from ui.ui_keycode import Ui_Dialog




class FormKeyCode(QtGui.QDialog):

    def __init__(self, parent=None, key=0):
        QtGui.QDialog.__init__(self, parent)
        self.ui = Ui_Dialog()
        self.ui.setupUi(self)
        self.retval = False

        if key:
            self.ui.spinCodigo.setValue(key)
            if key < 256:
                self.ui.editChar.setText(chr(key))
            self.ui.editTecla.setText(QtCore.Qt.Key(key).name[4:])
    def keyPressEvent(self, event):
        tecla = QtCore.Qt.Key(event.key())
        tecla = tecla.name[4:]
        try:
            nk = event.nativeVirtualKey()
            key_char = chr(nk) if nk < 256 else ''
            if not key_char: key_char = chr(event.key())

            self.ui.editChar.setText(key_char)
        except Exception as e:
            print e
            self.ui.editChar.clear()
        self.ui.editTecla.setText(tecla)
        self.ui.spinCodigo.setValue(event.key())

    def close(self):
        self.retval = self.ui.spinCodigo.value()
        print 'c'
        return super(FormKeyCode, self).close()

def key_dlg_show(parent=None, key=False):
    key_dlg = FormKeyCode(parent=parent, key=key)
    key_dlg.exec_()
    return key_dlg.retval

if __name__ == "__main__":
    app = QtGui.QApplication(sys.argv)
    dialog = FormKeyCode(key=48)
    dialog.show()
    app.exec_()
#    sys.exit(app.exec_())