#!/usr/bin/python
# -*- encoding: utf-8 -*-

from elixir import Entity, Field
from elixir.options import using_options, using_table_options
from sqlalchemy import Integer, String, UniqueConstraint, VARCHAR
from sigpdv.models.db_utils import a_metadata, a_session


class CaixaCadBandeiras(Entity):
    """
    Tabela de cadastro de bandeiras
    Prefixo: supban
    """
    using_options(metadata=a_metadata, session=a_session, tablename='caixa_cad_bandeiras')

    id = Field(Integer(11), primary_key=True, autoincrement=True)
    supban_codigo = Field(Integer(6), nullable=True)
    name = Field(String(30))
    supban_descricao_completa = Field(String(40))
    supban_tipo = Field(VARCHAR(1))

    # _sql_constraints
    using_table_options(UniqueConstraint('supban_codigo', 'name', 'supban_tipo'))

    def __repr__(self):
        _repr = "<caixa_cad_bandeiras: %d, 'Nome=%s'>"
        vals = self.supban_codigo, self.name
        return _repr % vals