#!/usr/bin/python
# -*- encoding: utf-8 -*-

from sigpdv.models.db_utils import a_metadata, a_session
from elixir.options import using_options, using_table_options
from elixir import Entity, Field
from sqlalchemy import SmallInteger, Enum, VARCHAR, UniqueConstraint


class CaixaCadNfeCfop(Entity):
    """
    Tabela de Cadastros de CFOPs
    prefixo: supcfop
    """
    using_options(metadata=a_metadata, session=a_session, tablename='caixa_cad_cfop')

    supcfop_codigo = Field(SmallInteger(4), primary_key=True, autoincrement=False)
    name = Field(VARCHAR(255))
    supcfop_tipo = Field(Enum('E', 'S', name='tipo'))
    supcfop_analitico_sintetico = Field(Enum('A', 'S', name='sintetico'))
    supcfop_movimento_tipo = Field(Enum('C', 'D', 'T', 'E', 'R', 'U', name='mov_tipo'))
    supcfop_transacao_tipo = Field(Enum('C', 'I', 'S', 'O', name='tras_tipo'))
    supcfop_produto_servico_tipo = Field(Enum('P', 'F', 'M', 'S', 'E', 'L', 'O', name='prod_serv'))

    # _sql_constraints
    using_table_options(UniqueConstraint('supcfop_codigo'))

    def __repr__(self):
        _repr = "<nfe_cfop: %d, u'Descrição=%s'>"
        vals = self.supcfop_codigo, self.name
        return _repr % vals