#!/usr/bin/python
# -*- coding: utf-8 -*-

from sigpdv.models.db_utils import a_metadata, a_session
from elixir import Entity, Field
from elixir.options import using_options
from sqlalchemy import Integer, String


class CaixaCadComandosImpressoras(Entity):
    """
    Tabela de Comandos de impressoras
    Prefixo: supcci
    """
    using_options(metadata=a_metadata, session=a_session, tablename='caixa_cad_comandos_impressoras')

    id = Field(Integer(11), primary_key=True, autoincrement=True)
    supcci_marca = Field(String(20))
    supcci_modelo = Field(String(20))
    supcci_negrito_liga = Field(String(20))
    supcci_negrito_desliga = Field(String(20))
    supcci_sub_liga = Field(String(20))
    supcci_sub_desliga = Field(String(20))
    supcci_fonte_liga = Field(String(20))
    supcci_fonte_desliga = Field(String(20))
    supcci_fonte_cond_liga = Field(String(20))
    supcci_fonte_cond_desliga = Field(String(20))
    supcci_corta_papel = Field(String(20))
    supcci_espacamento_linha = Field(String(20))
    supcci_gaveta = Field(String(20))

    def __repr__(self):
        _repr = "<caixa_cad_comandos_impressoras: Marca: %s, 'Modelo: %s'>"
        vals = self.supcci_marca, self.supcci_modelo
        return _repr % vals