#!/usr/bin/python
# -*- encoding: utf-8 -*-

from datetime import datetime
from sigpdv.tools.log import traced as Log
from sigpdv.models.db_utils import a_metadata, a_session
from elixir import Entity, Field
from elixir.options import using_options, using_table_options
from sqlalchemy import SmallInteger, Integer, String, DateTime, UniqueConstraint


class CaixaCadFinalizadoraNaEcf(Entity):
    """
    Cadastro de nomes de finalizadoras na ecf
    Prefixo: supfec
    """
    using_options(metadata=a_metadata, session=a_session, tablename='caixa_cad_finalizadora_na_ecf')

    id = Field(Integer(11), primary_key=True, autoincrement=True)
    supfec_codigo_na_ecf = Field(SmallInteger(10), index=True)
    name = Field(String(30))
    last_update = Field(DateTime, default=datetime.now())

    # _sql_constraints
    using_table_options(UniqueConstraint('supfec_codigo_na_ecf'))

    def __repr__(self):
        _repr = "<caixa_cad_finalizadora_na_ecf: %d - %s>"
        vals = self.supfec_codigo_na_ecf, self.name
        return _repr % vals