#!/usr/bin/python
# -*- encoding: utf-8 -*-

from datetime import datetime
from sigpdv.models.db_utils import a_metadata, a_session
from elixir import Entity, Field
from elixir.options import using_options
from sqlalchemy import Integer, SmallInteger, String, DateTime, DECIMAL


class CaixaCadKits(Entity):
    """
    Tabela de Kits
    Prefixo: supkit
    """
    using_options(metadata=a_metadata, session=a_session, tablename='caixa_cad_kits')

    id = Field(Integer(11), primary_key=True, autoincrement=True)
    supkit_loja = Field(SmallInteger(6), primary_key=True, autoincrement=False)
    supkit_codigo_kit = Field(Integer(11), primary_key=True, autoincrement=False, index=True)
    supkit_codigo_item = Field(Integer(11), primary_key=True, autoincrement=False, index=True)
    supkit_codigo_barra_kit = Field(String(14), primary_key=True, autoincrement=False, index=True)
    supkit_codigo_barra_item = Field(String(14), primary_key=True, autoincrement=False, index=True)
    supkit_quantidade = Field(DECIMAL(10, 3))
    supkit_preco_venda = Field(DECIMAL(15, 2))
    last_update = Field(DateTime, default=datetime.now())

    def __repr__(self):
        _repr = "<caixa_cad_kits: %s, 'Cod. Item=%s'>"
        vals = self.supkit_codigo_barra_kit, self.supkit_codigo_barra_item
        return _repr % vals