#!/usr/bin/python
# -*- coding: utf-8 -*-

from sigpdv.models.db_utils import a_metadata, a_session
from elixir import Entity, Field
from elixir.options import using_options, using_table_options
from sqlalchemy import Integer, String, UniqueConstraint

class CaixaCadListaClientes(Entity):
    """
    Tabela de Cadastro da relacao entre clientes e promocoes, para uma promocao ser dada apenas a 
    um grupo especifico de clientes
    Prefixo: supclc
    """
    using_options(metadata=a_metadata, session=a_session, tablename='caixa_cad_lista_clientes')

    id = Field(Integer(11), primary_key=True, autoincrement=True, index=True)
    supclc_cnpj_cpf = Field(String(15), primary_key=True, autoincrement=False, index=True)
    supclc_id_promo = Field(Integer(11), index=True)

    # _sql_constraints
    using_table_options(UniqueConstraint('supclc_cnpj_cpf', 'supclc_id_promo'))

    def __repr__(self):
        _repr = "<caixa_cad_lista_clientes: 'CPF/CNPJ=%s', 'Promo ID=%s'>"
        vals = self.supclc_cnpj_cpf, self.supclc_id_promo
        return _repr % vals