#!/usr/bin/python
# -*- encoding: utf-8 -*-

from datetime import datetime
from sigpdv.models.db_utils import a_metadata, a_session
from elixir import Entity, Field
from elixir.options import using_options
from sqlalchemy import String, Integer, CHAR, DateTime


class CaixaCadMensagensClientes(Entity):
    """
    Tabela de mensagens de clientes
    Prefixo: supclm
    """
    using_options(metadata=a_metadata, session=a_session, tablename='caixa_cad_mensagens_clientes')

    id = Field(Integer(11), primary_key=True, autoincrement=True)
    supclm_cnpj_cpf = Field(String(15), primary_key=True, autoincrement=False, index=True)
    supclm_sequencia = Field(Integer(11), primary_key=True, autoincrement=False)
    supclm_mensagem = Field(String(40))
    supclm_tipo = Field(CHAR(1))
    last_update = Field(DateTime, default=datetime.now())

    def __repr__(self):
        _repr = "<caixa_cad_mensagens_clientes: %d/%s, 'Mensagem=%s', 'Tipo=%s'>"
        vals = self.supclm_sequencia, self.supclm_cnpj_cpf, self.supclm_mensagem, self.supclm_tipo
        return _repr % vals