#!/usr/bin/python
# -*- encoding: utf-8 -*-

from elixir import Entity, Field
from elixir.options import using_options
from sqlalchemy.sql.expression import text
from sqlalchemy import Boolean, SmallInteger, CHAR, Integer, String
from sigpdv.models.db_utils import a_metadata, a_session


class CaixaCadMesas(Entity):
    """
    Tabela de Cadastro de Mesas
    Prefixo: supmes
    """
    using_options(metadata=a_metadata, session=a_session, tablename='caixa_cad_mesas')

    id = Field(Integer(11), primary_key=True, autoincrement=True)
    supmes_loja = Field(SmallInteger(1), primary_key=True, autoincrement=False)
    supmes_numero = Field(SmallInteger(6), primary_key=True, autoincrement=False)
    active = Field(Boolean, server_default=text('True'))
    supmes_tipo = Field(CHAR(1), server_default=text('False'))
    name = Field(String(30))

    def __repr__(self):
        _repr = "caixa_cad_mesas: %d, 'Ativo=%s', 'Descricao=%s'>"
        vals = self.supmes_numero, self.active, self.name
        return _repr % vals