#!/usr/bin/python
# -*- encoding: utf-8 -*-

from sigpdv.models.db_utils import a_metadata, a_session
from elixir import Entity, Field
from elixir.options import using_options, using_table_options
from sqlalchemy import Boolean, String, text, Integer, VARCHAR, UniqueConstraint


class CaixaCadModelosNfe(Entity):
    """
    Tabela de modelos de nfe
    Prefixo: supmnf
    """
    using_options(metadata=a_metadata, session=a_session, tablename='caixa_cad_modelos_nfe')

    id = Field(Integer(11), primary_key=True, autoincrement=True)
    supmnf_codigo = Field(VARCHAR(2), primary_key=True, autoincrement=False)
    name = Field(String(100))
    supmnf_serie = Field(Integer(3))
    supmnf_numeracao = Field(Integer(8))
    supmnf_active = Field(Boolean, server_default=text('False'))

    # _sql_constraints
    using_table_options(UniqueConstraint('supmnf_codigo', 'supmnf_serie'))

    def __repr__(self):
        _repr = "<caixa_modelos_nfe: %s, u'Descrição=%s'>"
        vals = self.supmnf_codigo, self.name
        return _repr % vals