#!/usr/bin/python
# -*- coding: utf-8 -*-

from elixir import Entity, Field
from elixir.options import using_options
from sqlalchemy import VARCHAR, Integer
from sigpdv.models.db_utils import a_metadata, a_session


class CaixaCadOperadoraCartao(Entity):
    """
    Tabela de Cadastro de Operadora de Cartao
    Prefixo: supopc
    """
    using_options(metadata=a_metadata, session=a_session, tablename='caixa_cad_operadora_cartao')

    id = Field(Integer(11), primary_key=True, autoincrement=True)
    supopc_codigo = Field(VARCHAR(5), index=True)
    name = Field(VARCHAR(30))
    supopc_cnpj = Field(VARCHAR(15), index=True)


    def __repr__(self):
        _repr = "<caixa_cad_operadora_cartao: %d, 'Nome=%s'>"
        vals = self.supope_codigo, self.name
        return _repr % vals