#!/usr/bin/python
# -*- encoding: utf-8 -*-

from sigpdv.models.db_utils import a_metadata, a_session
from elixir import Entity, Field
from elixir.options import using_options
from sqlalchemy import SmallInteger, Integer, \
     ForeignKey, DECIMAL, CHAR


class CaixaCadPromo1(Entity):
    """
    Tabela de Cadastro de promocoes
    Prefixo: suppro1
    """
    using_options(metadata=a_metadata, session=a_session, tablename='caixa_cad_promo1')

    id = Field(Integer(11), primary_key=True, autoincrement=True, index=True)
    suppro1_capa_id = Field(Integer(11),
                            ForeignKey('caixa_cad_promo_capa.id', ondelete="cascade"), required=True,
                            index=True)
    suppro1_barras = Field(CHAR(14))
    suppro1_quantidade = Field(DECIMAL(10, 3))
    suppro1_desconto = Field(DECIMAL(10, 2))
    suppro1_tipo_desconto = Field(CHAR(1)) # % ou $
    suppro1_sequencial = Field(SmallInteger(2),index=True)


    def __repr__(self):
        _repr = "<caixa_cad_promo_capa: %s, 'Codigo de barra=%s'>"
        vals = self.suppro1_capa_id, self.suppro1_barras
        return _repr % vals