#!/usr/bin/python
# -*- encoding: utf-8 -*-

from sigpdv.models.db_utils import a_metadata, a_session
from elixir import Entity, Field
from elixir.options import using_options
from sqlalchemy import SmallInteger, Integer, \
     ForeignKey, DECIMAL, CHAR


class CaixaCadPromo3f(Entity):
    """
    Tabela de Cadastro de promocoes
    Prefixo: suppro3f
    """
    using_options(metadata=a_metadata, session=a_session, tablename='caixa_cad_promo3f')

    id = Field(Integer(11), primary_key=True, autoincrement=True, index=True)
    suppro3f_capa_id = Field(Integer(11),
                            ForeignKey('caixa_cad_promo_capa.id', ondelete="cascade"), required=True,
                            index=True)
    suppro3f_barras = Field(CHAR(14))
    suppro3f_quantidade = Field(DECIMAL(10, 3))
    suppro3f_desconto = Field(DECIMAL(10, 2))
    suppro3f_tipo_desconto = Field(CHAR(1)) # % ou $

    def __repr__(self):
        _repr = "<caixa_cad_promo_capa: %s, 'Codigo de barra=%s'>"
        vals = self.suppro3f_capa_id, self.suppro3f_barras
        return _repr % vals
