#!/usr/bin/python
# -*- encoding: utf-8 -*-

from sigpdv.models.db_utils import a_metadata, a_session
from elixir import Entity, Field
from elixir.options import using_options
from sqlalchemy import Date, Integer, CHAR, DECIMAL, TEXT


class CaixaCadSorteio(Entity):
    """
    Tabela de Cadastro de sorteios
    Prefixo: supsor
    """
    using_options(metadata=a_metadata, session=a_session, tablename='caixa_cad_sorteio')

    id = Field(Integer(11), primary_key=True, autoincrement=True, index=True)

    supsor_data_inicio = Field(Date, index=True)
    supsor_data_fim = Field(Date, index=True)
    supsor_valor = Field(DECIMAL(10, 2))
    supsor_descricao = Field(TEXT())

    def __repr__(self):
        _repr = "<caixa_cad_sorteio: %s, 'Data init.=%s', 'Data fim.=%s'>"
        vals = self.supsor_id_promo, str(self.supsor_data_inicio), str(self.supsor_data_fim)
        return _repr % vals