#!/usr/bin/python
# -*- coding: utf-8 -*-

from datetime import datetime
from sigpdv.models.db_utils import a_metadata, a_session
from elixir import Entity, Field
from elixir.options import using_options, using_table_options
from sqlalchemy import Integer, String, DateTime, DECIMAL, VARCHAR, CHAR, UniqueConstraint


class CaixaCadTributacaoNfce(Entity):
    """
    Tabela de Tributacao
    Prefixo: suptnf
    """
    using_options(metadata=a_metadata, session=a_session, tablename='caixa_cad_tributacao_nfce')

    id = Field(Integer(11), primary_key=True, autoincrement=True)
    suptnf_codigo =  Field(Integer(11))
    suptnf_aliquota = Field(DECIMAL(5, 2))
    suptnf_base = Field(DECIMAL(5, 2))
    suptnf_encargo = Field(CHAR(1))
    suptnf_codigo_cst = Field(CHAR(2))
    suptnf_codigo_csosn = Field(CHAR(3))
    suptnf_tipo_tributacao = Field(CHAR(2))
    suptnf_aliquota_fcp = Field(DECIMAL(5, 2))
    suptnf_codigo_beneficio = Field(CHAR(10))
    suptnf_motivo_beneficio = Field(CHAR(2))

    # _sql_constraints
    using_table_options(UniqueConstraint('suptnf_codigo'))

    def __repr__(self):
        _repr = "<caixa_cad_tributacao: %s, 'Aliquota=%s', 'CST=%s'>"
        vals = self.suptnf_encargo, self.suptnf_aliquota, self.suptnf_codigo_cst
        return _repr % vals