#!/usr/bin/python
# -*- coding: utf-8 -*-

from sigpdv.models.db_utils import a_metadata, a_session
from elixir import Entity, Field
from elixir.options import using_options
from sqlalchemy import Integer, DECIMAL


class CaixaCadTributacaoSimplesNacional(Entity):
    """
    Tabela de Tributacao de Simples Nacional
    Prefixo: suptsn
    """
    using_options(metadata=a_metadata, session=a_session, tablename='caixa_tributacao_simples_nacional')

    id = Field(Integer(11), primary_key=True, autoincrement=True)
    suptsn_valor_faturamento = Field(DECIMAL(15, 2))
    suptsn_aliq_irpj = Field(DECIMAL(5, 2))
    suptsn_aliq_csll = Field(DECIMAL(5, 2))
    suptsn_aliq_cofins = Field(DECIMAL(5, 2))
    suptsn_aliq_pis = Field(DECIMAL(5, 2))
    suptsn_aliq_inss = Field(DECIMAL(5, 2))
    suptsn_aliq_icms = Field(DECIMAL(5, 2))


    def __repr__(self):
        _repr = "<caixa_cad_tributacao Faturamento: R$ %s>"
        vals = self.suptsn_valor_faturamento
        return _repr % vals