#!/usr/bin/python
# -*- encoding: utf-8 -*-

from datetime import datetime
from sigpdv.models.db_utils import a_metadata, a_session
from elixir import Entity, Field
from elixir.options import using_options
from sqlalchemy import Boolean, Integer, SmallInteger, String, text, Date


class CaixaCorNsu(Entity):
    """
    Tabela de Nsu
    Prefixo: supnsu
    """
    using_options(metadata=a_metadata, session=a_session, tablename='caixa_cor_nsu')

    supnsu_data_cupom = Field(Date(), primary_key=True, autoincrement=False,
                              default=datetime.now().date())
    supnsu_loja = Field(SmallInteger(6), primary_key=True, autoincrement=False)
    supnsu_caixa = Field(SmallInteger(6), primary_key=True, autoincrement=False)
    supnsu_nro_cupom_venda = Field(Integer(11), primary_key=True, autoincrement=False)
    supnsu_tef_nsu = Field(String(15))
    supnsu_tef_finalizacao = Field(String(15))
    supnsu_tef_rede = Field(String(15))
    supnsu_tef_data_transacao = Field(String(10))
    supnsu_tef_hora_transacao = Field(String(8))
    supnsu_tef_confirmado = Field(Boolean(), server_default=text('False'))

    def __repr__(self):
        _repr = "<caixa_cor_nsu: %s, 'NroCupom=%d', 'DataCupom=%s', 'Loja=%d', 'Caixa=%d>"
        vals = self.supnsu_tef_finalizacao, self.supnsu_nro_cupom_venda, self.supnsu_data_cupom, \
            self.supnsu_loja, self.supnsu_caixa
        return _repr % vals