#!/usr/bin/python
# -*- encoding: utf-8 -*-

from sigpdv.models.db_utils import a_metadata, a_session
from elixir import Entity, Field
from elixir.options import using_options
from sqlalchemy import String, Integer, CHAR, ForeignKey, Boolean, text


class CaixaMovAutorizacoes(Entity):
    """
    Tabela de autorizacoes
    Prefixo: supaut
    """
    using_options(metadata=a_metadata, session=a_session, tablename='caixa_mov_autorizacoes')

    id = Field(Integer(11), primary_key=True, autoincrement=True)
    supaut_capa_id = Field(Integer(11),
                           ForeignKey('caixa_mov_capa.id', onupdate="cascade", ondelete="cascade"))
    supaut_autorizador_id = Field(Integer(11))
    supaut_liberou_desconto = Field(Boolean, server_default=text('True'))
    supaut_liberou_limite_credito = Field(Boolean, server_default=text('True'))
    supaut_liberou_cheque_a_vista = Field(Boolean, server_default=text('True'))
    supaut_liberou_restricao_mensagem = Field(Boolean, server_default=text('True'))
    supaut_liberou_cancelamento_cupom = Field(Boolean, server_default=text('False'))
    supaut_cliente = Field(String(15), server_default=text("''"))

    def __repr__(self):
        _repr = "<Capa_id: %s, 'Autorizador=%s'>"
        vals = self.supaut_capa_id, self.supaut_autorizador_id
        return _repr % vals