#!/usr/bin/python
# -*- encoding: utf-8 -*-

from sigpdv.models.db_utils import a_metadata, a_session
from elixir import Entity, Field
from elixir.options import using_options
from sqlalchemy import SmallInteger, Integer, CHAR, Enum, DateTime, ForeignKey


class CaixaMovCaixa(Entity):
    """
    Tabela de Caixa
    Prefixo: supcax
    """
    using_options(metadata=a_metadata, session=a_session, tablename='caixa_mov_caixa')

    id = Field(Integer(11), primary_key=True, autoincrement=True)
    supcax_loja = Field(SmallInteger(6))
    supcax_caixa = Field(SmallInteger(6))
    supcax_data_hora_abertura = Field(DateTime())
    supcax_data_hora_fechamento = Field(DateTime())
    supcax_fechado = Field(CHAR(1))
    supcax_operador_id = Field(Integer(11), ForeignKey('caixa_cad_operadores.id',
                                                       onupdate="cascade",
                                                       ondelete="cascade"))
    supcax_enviado = Field(Enum('S', 'N', name='enviado'))

    def __repr__(self):
        _repr = "<caixa_mov_caixa: 'Loja=%d', 'Caixa=%d', 'Status=%s'>"
        vals = self.supcax_loja, self.supcax_caixa, self.supcax_fechado
        return _repr % vals