#!/usr/bin/python
# -*- encoding: utf-8 -*-

from datetime import datetime
from sigpdv.models.db_utils import a_metadata, a_session
from elixir import Entity, Field
from elixir.options import using_options
from sqlalchemy import SmallInteger, String, CHAR, DateTime, DECIMAL, text


class CaixaMovItensMesa(Entity):
    """
    Tabela de itens de Controle de Mesas
    Prefixo: supmes
    """
    using_options(metadata=a_metadata, session=a_session, tablename='caixa_mov_itens_mesa')

    id = Field(SmallInteger(6), primary_key=True, autoincrement=True)
    supims_loja = Field(SmallInteger(6), primary_key=True, autoincrement=False)
    supims_caixa = Field(SmallInteger(6), primary_key=True, autoincrement=False)
    supims_mov_mesa = Field(SmallInteger(6), primary_key=True, autoincrement=False)
    supims_sequencia = Field(SmallInteger(5), primary_key=True, autoincrement=False)
    supims_data_hora = Field(DateTime(), default=datetime.now())
    supims_item = Field(CHAR(14))
    supims_descricao = Field(String(30))
    supims_quantidade = Field(DECIMAL(10, 2))
    supims_unidade = Field(String(3))
    supims_vr_unit = Field(DECIMAL(10, 2))
    supims_vr_total = Field(DECIMAL(10, 3))
    supims_tributacao = Field(String(3))
    supims_desconto_item = Field(DECIMAL(10, 3))
    supims_acrescimo_item = Field(DECIMAL(10, 3))
    supims_venda_cancelamento = Field(CHAR(1), server_default=text("'V'"))
    supims_transf_mesa = Field(SmallInteger(6), server_default=text('0'))

    def __repr__(self):
        _repr = "<caixa_mov_itens_mesa: %d, 'Item=[%s] %s'>"
        vals = self.supims_mov_mesa, self.supims_item, self.supims_descricao
        return _repr % vals