#!/usr/bin/python
# -*- encoding: utf-8 -*-

from datetime import datetime
from sigpdv.models.db_utils import a_metadata, a_session
from elixir import Entity, Field
from elixir.options import using_options
from sqlalchemy import Integer, SmallInteger, String, DateTime, DECIMAL


class CaixaMovKitsVendidos(Entity):
    """
    Tabela de Kits
    Prefixo: supkit
    """
    using_options(metadata=a_metadata, session=a_session, tablename='caixa_mov_kits_vendidos')

    id = Field(Integer(11), primary_key=True, autoincrement=True)
    supmkv_codigo_kit = Field(String(14))
    supmkv_quantidade = Field(DECIMAL(10, 3))

    def __repr__(self):
        _repr = "<caixa_mov_kits_vendidos: %s'>"
        vals = self.supmkv_codigo_kit
        return _repr % vals