#!/usr/bin/python
# -*- encoding: utf-8 -*-

from sigpdv.models.db_utils import a_metadata, a_session
from elixir.options import using_options
from elixir import Entity, Field
from sqlalchemy import BigInteger, SmallInteger, Integer, text, VARCHAR, DECIMAL, ForeignKey


class CaixaNfeItens(Entity):
    """
    Tabela de itens da nfe
    Prefixo: supnfo
    """
    using_options(metadata=a_metadata, session=a_session, tablename='caixa_nfe_corpos')

    id = Field(BigInteger, primary_key=True)
    supnfo_nf = Field(Integer(11),
                      ForeignKey('caixa_nfe_capa.id', onupdate="cascade"))
    supnfo_codigo_item = Field(VARCHAR(14))
    supnfo_descricao = Field(VARCHAR(60))
    supnfo_unidade = Field(VARCHAR(5), server_default=text("'und'"))
    supnfo_sequencia = Field(Integer(11))
    supnfo_quantidade = Field(DECIMAL(10, 3))
    supnfo_vr_desconto = Field(DECIMAL(10, 2))
    supnfo_vr_unitario = Field(DECIMAL(10, 2))
    supnfo_vr_preco_venda = Field(DECIMAL(10, 2))
    supnfo_vr_total_item = Field(DECIMAL(10, 2))
    supnfo_cfop_id = Field(SmallInteger)
    supnfo_vr_acrescimos = Field(DECIMAL(10, 2))
    supnfo_orig = Field(Integer(11))
    supnfo_cst = Field(Integer(11))
    supnfo_mod_bc = Field(Integer(11))
    supnfo_p_icms = Field(DECIMAL(10, 2))
    supnfo_p_red_bc = Field(DECIMAL(10, 2))
    supnfo_v_bc = Field(DECIMAL(10, 2))
    supnfo_v_icms = Field(DECIMAL(10, 2))

    def __repr__(self):
        _repr = "<nfe_itens: %s, 'seq=%d', 'descricao=%s', 'Valor=R$ %.2f'>"
        vals = self.id, self.supnfo_sequencia, self.supnfo_descricao, self.supnfo_vr_unitario
        return _repr % vals