import os, re
import shutil
from distutils.core import setup
from setuptools import find_packages
from os.path import join, dirname
from version import version, revision

libs      = [ 'libs', 'sigtef' ]
resources = [ 'resources', '_utils' ]

packages  = find_packages()
packages += libs
packages += resources


def find_package_dir():
    pkg_dir = {}
    for pkg in packages:
        for root, dirnames, filenames in os.walk(pkg):
            pkg_dir.setdefault(pkg, join(root,'')[:-1])
            break

    pkg_dir['pdv'] = 'pdv'
    return pkg_dir

def find_root_files():
    root_files = []

    for root, dirnames, filenames in os.walk('.'):
        root_files.extend(filenames)
        break

    return root_files

def find_package_data():
    pkg_data = {}

    for pkg in packages:
        for root, dirnames, filenames in os.walk(pkg):
            for filename in filenames:
                if not re.match(r'.*(\.py|\.pyc|\.pyo|\~)$', filename):
                    pkg_data.setdefault(pkg, []).append(join(root.replace(pkg+'/',''), filename))

    return pkg_data


if os.path.exists('./pdv'):
    for root, dirnames, filenames in os.walk('./pdv'):
        for filename in filenames:
            os.unlink('./pdv/'+filename)
        break
else:
    os.mkdir('./pdv')

for f in find_root_files():
    if not re.match(r'(setup.py|Makefile|MANIFEST.in)$', f):
        shutil.copy(f,'./pdv/'+f)


setup(
    name='sigpdv',
    version=u'%s.%s' % tuple([str(e).upper() for e in version]),
    url='https://sigsolucoes.net.br',
    license='Proprietary',
    author='SIG Solucoes Ltda',
    author_email='comercial@sigsolucoes.net.br',
    description='Frente de Loja',
    packages=packages,
    package_dir=find_package_dir(),
    package_data=find_package_data(),
    include_package_data=True,    
)

