#!/usr/bin/python
# -*- encoding: utf-8 -*-

__autor__ = 'Dener Rodrigues'

from sigpdv.models.mov_capa_data import CaixaMovCapa
from sigpdv.models.mov_fechamentos_data import CaixaMovFechamentos
from sigpdv.control.mov_cupom_servidor import MovCupomServidor
from sigpdv.models.db_utils import sess
from sigpdv.control.fiscal_printer import FiscalPrinterHelper
from sigpdv.tools.config import config


class RecargaCelular():
    def __init__(self, parent):
        self._parent = parent

    def totalizar_recarga(self, value, supfin_tipo_finalizadora):
        self._parent.obj_fiscal_printer.add_value_to_counter('RC', value, supfin_tipo_finalizadora)
        self.gerar_capa(value, supfin_tipo_finalizadora)

    def gerar_capa(self, total_cupom, tipo_finalizadora):
        obj_impressora_fiscal = FiscalPrinterHelper(self._parent)
        tot = config['totalizador_recarga_cel']
        # a capa esta sendo gravada pelo tef interativo
        self._parent.obj_cupom_fiscal.cria_capa_cupom_gerencial(cod_totalizador=tot,
                                                                valor=total_cupom, tipo='R')
        capa = self._parent.mov_capa
        self.gerar_fechamentos(capa.id, total_cupom, tipo_finalizadora)
        MovCupomServidor().create({'supcse_capa_id': capa.id, 'supcse_enviado': 'F'})
        return capa.id

    def gerar_fechamentos(self, capa_id, total_cupom, tipo_finalizadora):
        sess.begin()
        fechamentos = CaixaMovFechamentos(supfec_capa_id=capa_id,
                                          supfec_sequencia=1,
                                          supfec_finalizadora=0,
                                          supfec_tipo_finalizadora=tipo_finalizadora,
                                          supfec_valor=total_cupom)
        sess.commit()
        return fechamentos.id