#!/usr/bin/python
# -*- encoding: utf-8 -*-
import logging
import os
import sys
from config import LOG_FILE_EXPORTAR
from types import ClassType, FunctionType, MethodType
from datetime import datetime


class log_exportar(object):

    def __init__(self, stdout=True):
        # criar logger
        lgr = logging.getLogger('db_supervisor')
        lgr.setLevel(logging.DEBUG)
        lgr.propagate = 0
        # adicionar arquivo logger
        fh = logging.FileHandler(LOG_FILE_EXPORTAR)
        # criar formato e setar formato do cabeçalho
        frmt = logging.Formatter('%(asctime)s - %(name)s - %(levelname)s - %(message)s')
        fh.setFormatter(frmt)
        #adicionar para gravar no logger
        lgr.addHandler(fh)

        self._log = lgr
        self._stdout = stdout

    def debug(self, text):
        self._log.setLevel(logging.DEBUG)
        self._log.debug(text)  # This won't print to myapp.log

    def info(self, text):
        self._log.setLevel(logging.INFO)
        self._log.info(text)  # Neither will this.

    def warning(self, text):
        self._log.setLevel(logging.WARNING)
        self._log.warn(text)  # This will show up in the log file.

    def error(self, text):
        self._log.setLevel(logging.ERROR)
        self._log.error(text)  # and so will this.

    def critical(self, text):
        self._log.setLevel(logging.CRITICAL)
        self._log.critical(text)  # and this one too.

logExportar = log_exportar()