#!/usr/bin/env python
# -*- Mode: Python; coding: utf-8 -*-

import sys
from PySide import QtGui
from busca_obs_produto_ui import Ui_Dialog


class BuscaObsProduto(QtGui.QDialog):
    def __init__(self, parent=None, consulta=False):
        super(BuscaObsProduto, self).__init__()

        self.ui = Ui_Dialog()
        self.ui.setupUi(self)
        self.parent = parent
        self.ui.edt_obs_produto.setFocus()
        for i in self.ui.buttonBox.children():
            if type(i) == QtGui.QPushButton:
                i.setMinimumHeight(45)

        if not consulta:
            self.parent.obs_produto = ''
            self.ui.edt_obs_produto.setEnabled(True)
            for i in self.ui.buttonBox.children():
                if type(i) == QtGui.QPushButton and i.text() in ('&OK', 'OK'):
                    i.setEnabled(True)
                    i.setVisible(True)

        else:
            self.ui.edt_obs_produto.setText(self.parent.obs_produto)
            self.ui.edt_obs_produto.setEnabled(False)
            for i in self.ui.buttonBox.children():
                if type(i) == QtGui.QPushButton and i.text() in ('&OK', 'OK'):
                    i.setEnabled(False)
                    i.setVisible(False)

    def accept(self):
        self.parent.obs_produto = self.ui.edt_obs_produto.toPlainText()
        super(BuscaObsProduto, self).accept()

if __name__ == "__main__":
    app = QtGui.QApplication(sys.argv)
    form = BuscaObsProduto()
    form.show()
    sys.exit(app.exec_())
