# -*- Mode: Python; coding: utf-8 -*-

from PySide import QtGui, QtCore
from message_dialog import Ui_Dialog
import sys

MSG_INFO, MSG_ERROR, MSG_QUESTION = range(3)

class MessageDialog(QtGui.QDialog):
    def __init__(self, parent=None):
        super(MessageDialog, self).__init__()

        self.ui = Ui_Dialog()
        self.ui.setupUi(self)
        self.setAttribute(QtCore.Qt.WA_TranslucentBackground)
        self.setWindowFlags(QtCore.Qt.FramelessWindowHint)
        self.ui.buttonBox.setStandardButtons(QtGui.QDialogButtonBox.Ok|QtGui.QDialogButtonBox.Cancel)
        
    def set_caption(self, text):
        self.ui.label_caption.setText(text)
        return text

    def set_info_text(self, text):
        self.ui.label_info.setText(text)
        return text

    def set_type(self, type):
        if type == MSG_INFO:
            self.set_caption(u'Informação')
            self.ui.buttonBox.setStandardButtons(QtGui.QDialogButtonBox.Ok)
        elif type == MSG_ERROR:
            self.set_caption(u'Erro')
            self.ui.buttonBox.setStandardButtons(QtGui.QDialogButtonBox.Ok|QtGui.QDialogButtonBox.Cancel)
        elif type == MSG_QUESTION:
            self.ui.buttonBox.setStandardButtons(QtGui.QDialogButtonBox.Yes|QtGui.QDialogButtonBox.No)

    def accept(self):
        return super(MessageDialog, self).accept()

    def done(self, arg__1):
        return super(MessageDialog, self).done(arg__1)

    def reject(self):
        return super(MessageDialog, self).reject()


def message_dlg(type, text):
    msg_box = MessageDialog()
    msg_box.set_type(type)
    msg_box.set_info_text(text)
    return msg_box.exec_()

if __name__ == "__main__":
    app = QtGui.QApplication(sys.argv)
    nfeform = MessageDialog()
    message_dlg(MSG_QUESTION, u'Informação')
#    sys.exit(app.exec_())
