#!/usr/bin/python
# -*- encoding: utf-8 -*-

from elixir import Entity, Field
from elixir.options import using_options, using_table_options
from sqlalchemy import Enum, SmallInteger, Integer, String, UniqueConstraint, CHAR, TEXT
from sigpdv.models.db_utils import a_metadata, a_session


class CaixaWebsig(Entity):
    """
    Tabela de cadastro de sentencas sql
    Prefixo: websig
    """
    using_options(metadata=a_metadata, session=a_session, tablename='caixa_cad_websig')

    id = Field(Integer(11), primary_key=True, autoincrement=True)
    websig_sql_id = Field(String(20), index=True) # codigo do chamado com a versao
    websig_sql_name = Field(String(100))
    websig_sql_obs = Field(TEXT())
    websig_sql_momento = Field(CHAR(1), default='A') # 'A' = Anteste, 'B' = Depois
    websig_sql_tabela = Field(CHAR(64))
    websig_sql_sentenca = Field(TEXT())
    websig_sql_executado = Field(CHAR(1),default='N', index=True) # 'S' = Sim, 'N' = Nao
    websig_sql_resultado = Field(TEXT())
    websig_sql_export_xml = Field(TEXT())

    # _sql_constraints
    using_table_options(UniqueConstraint('websig_sql_id', 'websig_sql_name'))

    def __repr__(self):
        _repr = "<caixa_cad_websig: %d, 'Nome=%s'>"
        vals = self.websig_sql_id, self.websig_sql_name
        return _repr % vals